% !TEX program = xelatex
\documentclass[aspectratio=169,20pt]{beamer}
\usepackage{listings}

\usetheme{ost}

\title{Branch History Injection}
\subtitle{On the Effectiveness of Hardware Mitigations Against Cross-Privilege Spectre-v2 Attacks, Enrico Barberis et al.}
\date{24.11.2022}
\author{Marco III. and Petra}
\institute{Platform Security}

\begin{document}

\begin{frame}
    \titlepage
\end{frame}

% Marco
\begin{frame}{Content}
    \begin{columns}
        \begin{column}{.6\textwidth}
            \begin{itemize}
                \item Operating Systems Recap
                \item Branch Target Injection (BTI)  (aka Spectre-v2)
                \item Branch History Injection (BHI)  (aka Spectre-BHB)
                \item Conclusion
            \end{itemize} 
        \end{column}
        \begin{column}{.4\textwidth}
            \begin{figure}
                \includegraphics[height=8cm]{./images/spectre-logo.png}
                \caption{Spectre-v2}
            \end{figure}
        \end{column}
    \end{columns}
\end{frame}

% Marco
\begin{frame}{Context}{Operating Systems Recap}
    \begin{figure}
        \centering
        \includegraphics[width=\textwidth]{./images/computermodel.png}
        \caption{Operating Systems 2 Computer Model}
    \end{figure}
\end{frame}

% Marco
\begin{frame}{Definitions}{Operating Systems Recap}
    \begin{columns}
        \begin{column}{.3\textwidth}
            \begin{figure}
                \includegraphics[width=0.75\columnwidth]{./images/sidechannel}
                \caption{Side Channel Attack}
            \end{figure}
        \end{column}
        \begin{column}{.3\textwidth}
            \begin{figure}
                \includegraphics[width=\columnwidth]{./images/kernellevels}
                \caption{User Kernel Mode}
            \end{figure}
        \end{column}
        \begin{column}{.3\textwidth}
            \begin{figure}
                \includegraphics[height=8.5cm]{./images/return-oriented-programming}
                \caption{Return Oriented-Programming}
            \end{figure}
        \end{column}
    \end{columns}    
\end{frame}

% Marco
\begin{frame}{Performance Improvements}{Operating Systems Recap}
    \begin{enumerate}
        \item Execution Order \begin{itemize}
            \item In-Order Execution
            \item Out-of-Order Execution
        \end{itemize}
        \item Speculative Execution
        \item Branch Prediction
    \end{enumerate}
\end{frame}

% Petra
\begin{frame}{Paper Goal}
    \begin{enumerate}
        \item What is the current status of Spectre-v2 defenses?
        \item Can we still poison the target of kernel indirect branches from userland?
        \item Are such attacks still practical?
    \end{enumerate}
\end{frame}

% Petra
\begin{frame}{Branch Target Injection (BTI)}
    \begin{columns}
        \begin{column}{.4\textwidth}
            \begin{block}{Attack Idea}
                \begin{itemize}
                    \item Speculatively perform operations
                    \item Leak confidential information via a side-channel attack
                \end{itemize}
            \end{block}
        \end{column}
        \begin{column}{.4\textwidth}
            \begin{block}{Why is it so critical?}
                \begin{itemize}
                    \item Intel
                    \item ARM
                    \item AMD
                \end{itemize}
            \end{block}
        \end{column}
    \end{columns}
\end{frame}

\begin{frame}{Branch Target Injection (BTI)}
    \begin{figure}
        \center
        \includegraphics[height=10cm]{./images/btb-high-level.png}
        \caption{Branch Target Buffer}    
    \end{figure}
\end{frame}

\begin{frame}{Branch Target Injection (BTI)}
    \begin{figure}
        \center
        \includegraphics[height=10cm]{./images/bti-high-level.png}
        \caption{Branch Target Injection}    
    \end{figure}
\end{frame}

% Petra
\begin{frame}{Mitigations}{Branch Target Injection (BTI)}
    \begin{block}{Retpoline}
    \end{block}
    \begin{block}{Intel/AMD - (e)IBRS \footnote{(e)IBRS = (Enhanced -) Indirect Branch Restricted Speculation} and ARM - FEAT\_CSV2}
        \begin{figure}
            \center
            \includegraphics[height=7cm]{./images/eIBRS.png}    
            \caption{Branch Target Buffer with eIBRS}
        \end{figure}
    \end{block}
\end{frame}

% Marco
\begin{frame}{Branch History Injection (BHI)}
            \begin{figure}
                \centering
                \includegraphics[height=10cm]{./images/bhi-high-level.png}
                \caption{Branch History Injection}
            \end{figure}
\end{frame}

% Marco
\begin{frame}{BPU - Branch Prediction Unit}{Branch History Injection (BHI)}
    \begin{columns}
        \begin{column}{.3\textwidth}
            \begin{description}
                \item[F1] Hash Function
                \item[F2] Branch Context Hash
                \item[BHB] Branch History Buffer
                \item[BTB] Branch Target Buffer
            \end{description}
        \end{column}
        \begin{column}{.7\textwidth}
            \begin{figure}
                \center
                \includegraphics[height=11cm]{./images/branch-prediction-unit.png}
                \caption{Branch Prediction Unit}    
            \end{figure}
        \end{column}
    \end{columns}
\end{frame}

% Marco
\begin{frame}{BHI Attack Surface}{Branch History Injection (BHI)}
    \begin{columns}
        \begin{column}{.4\textwidth}
            \begin{block}{Attack}
                \begin{itemize}
                    \item Randomize BHB values \begin{itemize}
                        \item Randomize Branch History Buffer
                    \end{itemize}
                \end{itemize}
            \end{block}
        \end{column}
        \begin{column}{.5\textwidth}
            \begin{figure}
                \center
                \includegraphics[height=8cm]{./images/bhi-attack-surface.png} 
                \caption{BHI Attack Surface}   
            \end{figure}
        \end{column}
    \end{columns}
\end{frame}

% Petra
\begin{frame}{BHI Example}
    \begin{figure}
        \includegraphics[height=10cm]{./images/spectre-logo.png}
        \caption{Spectre Logo}
    \end{figure}
\end{frame}

% Petra
\begin{frame}{Initial Situation}{BHI Example}
    \begin{itemize}
        \item Linux kernel 5.14.10
        \item eIBRS enabled
        \item x86-64 based machine (Intel i7-10700K)
        \item No other exploitable vulnerabilities
        \item Attacker can run unprivileged code
    \end{itemize}
\end{frame}

% Petra
\begin{frame}{Attack}{BHI Example}
    \begin{figure}
        \center
        \includegraphics[height=13cm]{./images/bhi-exploitation.png}    
        \caption{Branch History Injection Example}
    \end{figure}
\end{frame}

% Marco
\begin{frame}{Mitigations}{Branch History Injection (BHI)}
    \begin{columns}[T]
        \begin{column}{.4\textwidth}
            \begin{block}{Intel}
                \begin{itemize}
                    \item Enable eIBRS and Supervisor-Mode Access Prevention (SMAP)
                    \item Fallback to Retpoline
                    \item Disabled the use of unprivileged eBPF 
                \end{itemize}
            \end{block}
        \end{column}
        \begin{column}{.5\textwidth}
            \begin{block}{ARM}
                \begin{itemize}
                    \item Flush BTB on context switch
                    \item eBPF remains vulnerable
                \end{itemize}
            \end{block}
        \end{column}
    \end{columns}
\end{frame}

% Petra
\begin{frame}{Paper Goal}{Branch History Injection (BHI)}
    \begin{enumerate}
        \item What is the current status of Spectre-v2 defenses? \\
        \textit{Some defenses work better than others.}
        \item Can we still poison the target of kernel indirect branches from userland? \\
        \textit{With BHI \footnote{ BHI = Branch History Injection } an unprivileged attacker can still control misspeculation of higher-privilege indirect branches.}
        \item Are such attacks still practical? \\
        \textit{Yes, they still allow still same-predictor-mode attacks which are practical.}
    \end{enumerate}
\end{frame}

% Petra
\begin{frame}{Paper Conclusion}{Branch History Injection (BHI)}
    \textbf{Attack State:}
    \begin{itemize}
        \item BTI \footnote{BTI = Branch Target Injection } are still possible on modern processors with in-silicon mitigations. \\ 
        (CVE-2022-0001)
        \item BHB\footnote{BHB = Branch History Injection}-based cross-privilege BTI attacks are not only feasible but also practical. \\
        (CVE-2022-0002 for intra-mode BTI)
    \end{itemize}

    \textbf{Countermeasures:}
    \begin{itemize}
        \item Re-enabling software defenses such as retpoline 
        \item Forbidding unprivileged access to exploitation-friendly features such as eBPF
    \end{itemize}
\end{frame}

% Petra
\begin{frame}{Impact}{Branch History Injection (BHI)}
    \textbf{Affected CPUs}
    \begin{itemize}
        \item Intel: All CPUs from the 10th Generation
        \item ARM: Most Cortex-A and -X CPUs
    \end{itemize}

    \textbf{What can I do to protect myself?}
    \begin{itemize}
        \item Enable software defenses
    \end{itemize}
\end{frame}

\begin{frame}{Questions}
    \begin{figure}
        \center
        \includegraphics[height=13cm]{./images/question.jpg}    
    \end{figure}
\end{frame}

\begin{frame}[fragile]{Mitigations Check BHI}
    \textbf{Linux \footnote{https://super-unix.com/unixlinux/linux-how-to-check-if-linux-kernel-is-retpoline-enabled-or-not/}:}
    \begin{lstlisting}
        cat /sys/devices/system/cpu/vulnerabilities/spectre_v2
    \end{lstlisting}
\end{frame}

\begin{frame}{Who is affected by BHI?}
    \begin{figure}
        \center
        \includegraphics[height=11cm]{./images/bhi-affected-processor.png}    
    \end{figure}
\end{frame}


\end{document}